Gentoo Archives: gentoo-commits

From: Ben Kohler <bkohler@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] repo/gentoo:master commit in: app-editors/gvim/
Date: Tue, 28 Feb 2023 16:28:51
Message-Id: 1677601719.04ed27394a6a02e2e61258e389d234872ac6fcfc.bkohler@gentoo
1 commit: 04ed27394a6a02e2e61258e389d234872ac6fcfc
2 Author: Ben Kohler <bkohler <AT> gentoo <DOT> org>
3 AuthorDate: Tue Feb 28 16:24:56 2023 +0000
4 Commit: Ben Kohler <bkohler <AT> gentoo <DOT> org>
5 CommitDate: Tue Feb 28 16:28:39 2023 +0000
6 URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=04ed2739
7
8 app-editors/gvim: add 9.0.1363
9
10 Signed-off-by: Ben Kohler <bkohler <AT> gentoo.org>
11
12 app-editors/gvim/Manifest | 1 +
13 app-editors/gvim/gvim-9.0.1363.ebuild | 370 ++++++++++++++++++++++++++++++++++
14 2 files changed, 371 insertions(+)
15
16 diff --git a/app-editors/gvim/Manifest b/app-editors/gvim/Manifest
17 index 56bc4f66ba32..207e0d1e8f7d 100644
18 --- a/app-editors/gvim/Manifest
19 +++ b/app-editors/gvim/Manifest
20 @@ -1,4 +1,5 @@
21 DIST vim-9.0.1000.tar.gz 16842747 BLAKE2B 85edab7d13daa3e84ef0aeb50e3e9bfd31f0634d8e480c105727b0c34318e0adf7f1276dcdac53df8fc416fd8dfb70377cd74ed570752a3e77f07a083fa6c113 SHA512 9d2b914a112948d77b92c8dcafc2f711a83c3fdaf35a28f7f606e77007b9320e2260a0f6b24fc875a817c33c012f077f89730b34e9f12d6f00795c5c806704c8
22 DIST vim-9.0.1157.tar.gz 16924574 BLAKE2B 0cdc6cf61f5abdaff0762b98550bfa5bae8f0485ddd0e9947a5fe52390f9da54fc8f5fdae767fb8f5d3ac2b441253917a80ae7f6092f67b69bdc9b6a630df8e2 SHA512 19240a9bcf5900766db42e2894b1bf7b849274711f17dc267671aacd867b334c3d30f39947dde7dd0245f289e9ad801eeb272f34a2ab15d01fac40bf71a54271
23 DIST vim-9.0.1341.tar.gz 16965673 BLAKE2B 2b58e68b06a7eb7104f77459be9ea202d979e3daae02073db29f24a07e20152c1f9f7f380e7569ab56ceef174658081bdde06db253827684d0731afb2f3fbbc6 SHA512 48e5232d629ccc9ee0093061d5340181083e22ff6b4eb0ad2e979a92be9c2a47b640ca1a58812da0f79a736f4b406a2541eb8fa4accd8213cf6ee9df1cd7f4fc
24 +DIST vim-9.0.1363.tar.gz 16974190 BLAKE2B 456114cd7e74836998b51e9272e9c9a12952146f42740b3df66e36ee8e47c8c0538341d9ac9c877c93e0b356fd9ca46a2016e9386d53e3cbfd51d0e2b113bc5a SHA512 2e79e104d9816438c14f94d0e858766129eb3f706b3a89a9761331d32b46b3f83eeadb2ce0d2ec14392a69122ab8761e57218c0e5731a4453d2b91f53a70c4c8
25 DIST vim-patches-vim-9.0.1000-patches.tar.bz2 3245 BLAKE2B 3bf3d0e314cc3f96d5d9675de196a62c4c8a72645d56ef94b80768571c99cba5cc556442e3bd2dfa8818460fd851fe7bd1ae15999af7225fb271b81c43105843 SHA512 2883441a2001bf7ce89a7f0862f780b71cc0164c8fcb8dbdf7040e1bcbcf408d138d3d77f308aa54c762e9975fa5ec89cfceeabbf721344dfc938870a363667a
26
27 diff --git a/app-editors/gvim/gvim-9.0.1363.ebuild b/app-editors/gvim/gvim-9.0.1363.ebuild
28 new file mode 100644
29 index 000000000000..cba104363a07
30 --- /dev/null
31 +++ b/app-editors/gvim/gvim-9.0.1363.ebuild
32 @@ -0,0 +1,370 @@
33 +# Copyright 1999-2023 Gentoo Authors
34 +# Distributed under the terms of the GNU General Public License v2
35 +
36 +EAPI=8
37 +
38 +# Please bump with app-editors/vim-core and app-editors/vim
39 +
40 +VIM_VERSION="9.0"
41 +VIM_PATCHES_VERSION="9.0.1000"
42 +
43 +LUA_COMPAT=( lua5-{1..4} luajit )
44 +PYTHON_COMPAT=( python3_{9..11} )
45 +PYTHON_REQ_USE="threads(+)"
46 +USE_RUBY="ruby27 ruby30 ruby31"
47 +
48 +inherit bash-completion-r1 flag-o-matic lua-single prefix python-single-r1 ruby-single toolchain-funcs vim-doc xdg-utils
49 +
50 +if [[ ${PV} == 9999* ]]; then
51 + inherit git-r3
52 + EGIT_REPO_URI="https://github.com/vim/vim.git"
53 + EGIT_CHECKOUT_DIR=${WORKDIR}/vim-${PV}
54 +else
55 + SRC_URI="https://github.com/vim/vim/archive/v${PV}.tar.gz -> vim-${PV}.tar.gz
56 + https://gitweb.gentoo.org/proj/vim-patches.git/snapshot/vim-patches-vim-${VIM_PATCHES_VERSION}-patches.tar.bz2"
57 + KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x86-solaris"
58 +fi
59 +S="${WORKDIR}"/vim-${PV}
60 +
61 +DESCRIPTION="GUI version of the Vim text editor"
62 +HOMEPAGE="https://www.vim.org https://github.com/vim/vim"
63 +
64 +LICENSE="vim"
65 +SLOT="0"
66 +IUSE="acl aqua crypt cscope debug lua minimal motif netbeans nls perl python racket ruby selinux session sound tcl"
67 +REQUIRED_USE="
68 + lua? ( ${LUA_REQUIRED_USE} )
69 + python? ( ${PYTHON_REQUIRED_USE} )
70 + aqua? ( !motif )
71 +"
72 +
73 +RDEPEND="
74 + ~app-editors/vim-core-${PV}
75 + >=app-eselect/eselect-vi-1.1
76 + >=sys-libs/ncurses-5.2-r2:0=
77 + x11-libs/libICE
78 + x11-libs/libSM
79 + x11-libs/libXext
80 + x11-libs/libXt
81 + acl? ( kernel_linux? ( sys-apps/acl ) )
82 + !aqua? (
83 + motif? ( >=x11-libs/motif-2.3:0 )
84 + !motif? (
85 + x11-libs/gtk+:3
86 + x11-libs/libXft
87 + )
88 + )
89 + crypt? ( dev-libs/libsodium:= )
90 + cscope? ( dev-util/cscope )
91 + lua? (
92 + ${LUA_DEPS}
93 + $(lua_gen_impl_dep 'deprecated' lua5-1)
94 + )
95 + nls? ( virtual/libintl )
96 + perl? ( dev-lang/perl:= )
97 + python? ( ${PYTHON_DEPS} )
98 + racket? ( dev-scheme/racket )
99 + ruby? ( ${RUBY_DEPS} )
100 + selinux? ( sys-libs/libselinux )
101 + session? ( x11-libs/libSM )
102 + sound? ( media-libs/libcanberra )
103 + tcl? ( dev-lang/tcl:0= )
104 +"
105 +DEPEND="${RDEPEND}
106 + x11-base/xorg-proto"
107 +# configure runs the Lua interpreter
108 +BDEPEND="
109 + sys-devel/autoconf
110 + virtual/pkgconfig
111 + lua? ( ${LUA_DEPS} )
112 + nls? ( sys-devel/gettext )
113 +"
114 +PDEPEND="!minimal? ( app-vim/gentoo-syntax )"
115 +
116 +if [[ ${PV} != 9999* ]]; then
117 + # Gentoo patches to fix runtime issues, cross-compile errors, etc
118 + PATCHES=(
119 + "${WORKDIR}/vim-patches-vim-${VIM_PATCHES_VERSION}-patches"
120 + )
121 +fi
122 +
123 +# various failures (bugs #630042 and #682320)
124 +RESTRICT="test"
125 +
126 +pkg_setup() {
127 + # people with broken alphabets run into trouble. bug 82186.
128 + unset LANG LC_ALL
129 + export LC_COLLATE="C"
130 +
131 + use lua && lua-single_pkg_setup
132 + use python && python-single-r1_pkg_setup
133 +}
134 +
135 +src_prepare() {
136 + default
137 +
138 + # Fixup a script to use awk instead of nawk
139 + sed -i -e \
140 + '1s|.*|#!'"${EPREFIX}"'/usr/bin/awk -f|' \
141 + "${S}"/runtime/tools/mve.awk || die "mve.awk sed failed"
142 +
143 + # Read vimrc and gvimrc from /etc/vim
144 + echo '#define SYS_VIMRC_FILE "'${EPREFIX}'/etc/vim/vimrc"' \
145 + >> "${S}"/src/feature.h || die "echo failed"
146 + echo '#define SYS_GVIMRC_FILE "'${EPREFIX}'/etc/vim/gvimrc"' \
147 + >> "${S}"/src/feature.h || die "echo failed"
148 +
149 + # Use exuberant ctags which installs as /usr/bin/exuberant-ctags.
150 + # Hopefully this pattern won't break for a while at least.
151 + # This fixes bug 29398 (27 Sep 2003 agriffis)
152 + sed -i -e \
153 + 's/\<ctags\("\| [-*.]\)/exuberant-&/g' \
154 + "${S}"/runtime/doc/syntax.txt \
155 + "${S}"/runtime/doc/tagsrch.txt \
156 + "${S}"/runtime/doc/usr_29.txt \
157 + "${S}"/runtime/menu.vim \
158 + "${S}"/src/configure.ac || die 'sed failed'
159 +
160 + # Don't be fooled by /usr/include/libc.h. When found, vim thinks
161 + # this is NeXT, but it's actually just a file in dev-libs/9libs
162 + # This fixes bug 43885 (20 Mar 2004 agriffis)
163 + sed -i -e \
164 + 's/ libc\.h / /' "${S}"/src/configure.ac || die 'sed failed'
165 +
166 + # gcc on sparc32 has this, uhm, interesting problem with detecting EOF
167 + # correctly. To avoid some really entertaining error messages about stuff
168 + # which isn't even in the source file being invalid, we'll do some trickery
169 + # to make the error never occur. bug 66162 (02 October 2004 ciaranm)
170 + find "${S}" -name '*.c' | while read c; do
171 + echo >> "$c" || die "echo failed"
172 + done
173 +
174 + # Try to avoid sandbox problems. Bug #114475.
175 + if [[ -d "${S}"/src/po ]]; then
176 + sed -i -e \
177 + '/-S check.vim/s,..VIM.,ln -s $(VIM) testvim \; ./testvim -X,' \
178 + "${S}"/src/po/Makefile || die
179 + fi
180 +
181 + cp -v "${S}"/src/config.mk.dist "${S}"/src/auto/config.mk || die "cp failed"
182 +
183 + # Bug #378107 - Build properly with >=perl-core/ExtUtils-ParseXS-3.20.0
184 + sed -i -e \
185 + "s:\\\$(PERLLIB)/ExtUtils/xsubpp:${EPREFIX}/usr/bin/xsubpp:" \
186 + "${S}"/src/Makefile || die 'sed for ExtUtils-ParseXS failed'
187 +
188 + # Fix bug 18245: Prevent "make" from the following chain:
189 + # (1) Notice configure.ac is newer than auto/configure
190 + # (2) Rebuild auto/configure
191 + # (3) Notice auto/configure is newer than auto/config.mk
192 + # (4) Run ./configure (with wrong args) to remake auto/config.mk
193 + sed -i -e \
194 + 's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed failed"
195 + rm -v src/auto/configure || die "rm failed"
196 +
197 + # --with-features=huge forces on cscope even if we --disable it. We need
198 + # to sed this out to avoid screwiness. (1 Sep 2004 ciaranm)
199 + if ! use cscope; then
200 + sed -i -e \
201 + '/# define FEAT_CSCOPE/d' src/feature.h || die "couldn't disable cscope"
202 + fi
203 +}
204 +
205 +src_configure() {
206 +
207 + # Fix bug 37354: Disallow -funroll-all-loops on amd64
208 + # Bug 57859 suggests that we want to do this for all archs
209 + filter-flags -funroll-all-loops
210 +
211 + # Fix bug 76331: -O3 causes problems, use -O2 instead. We'll do this for
212 + # everyone since previous flag filtering bugs have turned out to affect
213 + # multiple archs...
214 + replace-flags -O3 -O2
215 +
216 + emake -j1 -C src autoconf
217 +
218 + # This should fix a sandbox violation (see bug 24447). The hvc
219 + # things are for ppc64, see bug 86433.
220 + local file
221 + for file in /dev/pty/s* /dev/console /dev/hvc/* /dev/hvc*; do
222 + if [[ -e ${file} ]]; then
223 + addwrite $file
224 + fi
225 + done
226 +
227 + use debug && append-flags "-DDEBUG"
228 +
229 + local myconf=(
230 + --with-features=huge
231 + --disable-gpm
232 + --with-gnome=no
233 + $(use_enable sound canberra)
234 + $(use_enable acl)
235 + $(use_enable crypt libsodium)
236 + $(use_enable cscope)
237 + $(use_enable netbeans)
238 + $(use_enable nls)
239 + $(use_enable perl perlinterp)
240 + $(use_enable python python3interp)
241 + $(use_with python python3-command "${PYTHON}")
242 + $(use_enable racket mzschemeinterp)
243 + $(use_enable ruby rubyinterp)
244 + $(use_enable selinux)
245 + $(use_enable session xsmp)
246 + $(use_enable tcl tclinterp)
247 + )
248 +
249 + if use lua; then
250 + # -DLUA_COMPAT_OPENLIB=1 is required to enable the
251 + # deprecated (in 5.1) luaL_openlib API (#874690)
252 + use lua_single_target_lua5-1 && append-cppflags -DLUA_COMPAT_OPENLIB=1
253 +
254 + myconf+=(
255 + --enable-luainterp
256 + $(use_with lua_single_target_luajit luajit)
257 + --with-lua-prefix="${EPREFIX}/usr"
258 + )
259 + fi
260 +
261 + # Default is gtk unless aqua or motif are enabled
262 + echo ; echo
263 + if use aqua; then
264 + einfo "Building gvim with the Carbon GUI"
265 + myconf+=(
266 + --enable-darwin
267 + --enable-gui=carbon
268 + )
269 + elif use motif; then
270 + einfo "Building gvim with the MOTIF GUI"
271 + myconf+=( --enable-gui=motif )
272 + else
273 + myconf+=( --enable-gtk3-check )
274 + einfo "Building gvim with the gtk+-3 GUI"
275 + myconf+=( --enable-gui=gtk3 )
276 + fi
277 + echo ; echo
278 +
279 + # let package manager strip binaries
280 + export ac_cv_prog_STRIP="$(type -P true ) faking strip"
281 +
282 + # keep prefix env contained within the EPREFIX
283 + use prefix && myconf+=( --without-local-dir )
284 +
285 + if [[ ${CHOST} == *-interix* ]]; then
286 + # avoid finding of this function, to avoid having to patch either
287 + # configure or the source, which would be much more hackish.
288 + # after all vim does it right, only interix is badly broken (again)
289 + export ac_cv_func_sigaction=no
290 + fi
291 +
292 + if tc-is-cross-compiler ; then
293 + export vim_cv_getcwd_broken=no \
294 + vim_cv_memmove_handles_overlap=yes \
295 + vim_cv_stat_ignores_slash=yes \
296 + vim_cv_terminfo=yes \
297 + vim_cv_toupper_broken=no
298 + fi
299 +
300 + econf \
301 + --with-modified-by=Gentoo-${PVR} \
302 + --with-vim-name=gvim \
303 + --with-x \
304 + "${myconf[@]}"
305 +}
306 +
307 +src_compile() {
308 + # The following allows emake to be used
309 + emake -j1 -C src auto/osdef.h objects
310 +
311 + emake
312 +}
313 +
314 +src_test() {
315 + einfo
316 + einfo "Starting vim tests. Several error messages will be shown"
317 + einfo "while the tests run. This is normal behaviour and does not"
318 + einfo "indicate a fault."
319 + einfo
320 + ewarn "If the tests fail, your terminal may be left in a strange"
321 + ewarn "state. Usually, running 'reset' will fix this."
322 + einfo
323 +
324 + # Don't let vim talk to X
325 + unset DISPLAY
326 +
327 + # Make gvim not try to connect to X. See :help gui-x11-start in vim for how
328 + # this evil trickery works.
329 + ln -s "${S}"/src/gvim "${S}"/src/testvim || die
330 +
331 + # Make sure our VIMPROG is used.
332 + sed -i -e 's:\.\./vim:../testvim:' src/testdir/test49.vim || die
333 +
334 + # Don't do additional GUI tests.
335 + emake -j1 VIMPROG=../testvim -C src/testdir nongui
336 +}
337 +
338 +# Call eselect vi update with --if-unset
339 +# to respect user's choice (bug 187449)
340 +eselect_vi_update() {
341 + ebegin "Calling eselect vi update"
342 + eselect vi update --if-unset
343 + eend $?
344 +}
345 +
346 +src_install() {
347 + local vimfiles=/usr/share/vim/vim${VIM_VERSION/.}
348 +
349 + dobin src/gvim
350 + dosym gvim /usr/bin/gvimdiff
351 + dosym gvim /usr/bin/evim
352 + dosym gvim /usr/bin/eview
353 + dosym gvim /usr/bin/gview
354 + dosym gvim /usr/bin/rgvim
355 + dosym gvim /usr/bin/rgview
356 +
357 + emake -C src DESTDIR="${D}" DATADIR="${EPREFIX}"/usr/share install-icons
358 +
359 + dodir /usr/share/man/man1
360 + echo ".so vim.1" > "${ED}"/usr/share/man/man1/gvim.1 || die "echo failed"
361 + echo ".so vim.1" > "${ED}"/usr/share/man/man1/gview.1 || die "echo failed"
362 + echo ".so vimdiff.1" > "${ED}"/usr/share/man/man1/gvimdiff.1 || \
363 + die "echo failed"
364 +
365 + insinto /etc/vim
366 + newins "${FILESDIR}"/gvimrc-r1 gvimrc
367 + eprefixify "${ED}"/etc/vim/gvimrc
368 +
369 + # bash completion script, bug #79018.
370 + newbashcomp "${FILESDIR}"/${PN}-completion ${PN}
371 +
372 + # don't install vim desktop file
373 + rm -v "${ED}"/usr/share/applications/vim.desktop || die "failed to remove vim.desktop"
374 +}
375 +
376 +pkg_postinst() {
377 + # update documentation tags (from vim-doc.eclass)
378 + update_vim_helptags
379 +
380 + # update fdo mime stuff, bug #78394
381 + xdg_desktop_database_update
382 +
383 + # update icon cache
384 + xdg_icon_cache_update
385 +
386 + # call eselect vi update
387 + eselect_vi_update
388 +}
389 +
390 +pkg_postrm() {
391 + # update documentation tags (from vim-doc.eclass)
392 + update_vim_helptags
393 +
394 + # update fdo mime stuff, bug #78394
395 + xdg_desktop_database_update
396 +
397 + # update icon cache
398 + xdg_icon_cache_update
399 +
400 + # call eselect vi update
401 + eselect_vi_update
402 +}